Index: s390-tools-sles11/zipl/boot/dumpcommon.S
===================================================================
--- s390-tools-sles11.orig/zipl/boot/dumpcommon.S
+++ s390-tools-sles11/zipl/boot/dumpcommon.S
@@ -46,9 +46,9 @@
 #define ENOTIME          0x00000202  /* zipl time stamps do not match */
 
 #define __LC_ARCH_MODE_ID 163        /* here is the arch flag in the lowcore */
-#define __LC_EXT_NEW_PSW_S390  0x058
-#define __LC_EXT_NEW_PSW_S390X 0x01b0
-#define __LC_EXT_INT_CODE_ADDR 0x86
+#define __LC_IPIB         0xe00      /* IPL Parameter Information Block */
+#define DIAG308_IPL       3          /* Subcode 3 - Perform Load Clear  */
+#define DIAG308_SET       5          /* Subcode 5 - Set IPL Parameters  */
 
 #define PARAM_START        0x3000  /* 8-byte time stamp plus 2-byte count  */
                                    /* plus 32 13-byte entries              */
@@ -302,15 +302,37 @@ _wait4de_64:
 .Lpsw:  .long  0x0
 
 ################################################################################
-# Panik routine. Loads a disabled wait psw
+# Panik routine. Loads a disabled wait psw or performs reipl if required.
 #   -r2 : panik code
 ################################################################################
 
 _panik_64:
         stmg   %r6,%r15,48(%r15)
         basr   %r13,0                    # base register
-0:      stg    %r2,1f-0b+8(%r13)         # store code in address part of psw
+0:      aghi   %r15,-200                 # create stack frame
+	stg    %r2,1f-0b+8(%r13)         # store code in address part of psw
 	bras   %r14,_print_exit_message
+
+	# perform reipl: check lowcore for the address of an IPL Information
+	# Block followed by a valid checksum (as defined in lowcore.h and set
+	# by ipl.c). In case of match use diag308 to IPL.
+
+	lg    %r2,__LC_IPIB(%r0)                 # IPL Information Block
+	ltr   %r2,%r2                            # re-ipl required?
+	bz    .Lnoreipl-0b(%r13)                 # no, skip diag308
+	llgf  %r3,0(%r2)                         # length of IPIB
+	sr    %r1,%r1                            # zero accumator
+.Lcksmloop:
+	cksm  %r1,%r2                            # compute IPIB checksum
+	bnz   .Lcksmloop-0b(%r13)                # repeat if not complete
+	cl    %r1,__LC_IPIB+8(%r0)               # compare with cksm in lowcore
+	bne   .Lnoreipl-0b(%r13)                 # no match, skip diag308
+	lg    %r2,__LC_IPIB(%r0)                 # reload IPL Information Block
+	lghi  %r4,DIAG308_SET                    # load subcode
+	diag  %r2,%r4,0x308                      # set IPL parameters
+	lghi  %r4,DIAG308_IPL                    # load subcode
+	diag  %r2,%r4,0x308                      # perform load clear
+.Lnoreipl:
 	lpswe  1f-0b(%r13)
         .align 8
 1:      .long  0x00020000,0x80000000,0x00000000,0x00000000
@@ -621,7 +643,7 @@ _create_ida_list_64:
 _init_print_progress_32:
 	stm    %r6,%r15,24(%r15)
 	basr   %r13,0                   # base register
-0:	s      %r15,.Lc96-0b(%r13)
+0:	ahi    %r15,-96
 
 	l      %r2,.Ldh_mem_size+4-0b(%r13)	
 	srl    %r2,20
@@ -641,7 +663,7 @@ _init_print_progress_32:
 _print_progress_32:
 	stm    %r6,%r15,24(%r15)
 	basr   %r13,0                   # base register
-0:	s      %r15,.Lc96-0b(%r13)
+0:	ahi    %r15,-96
 
 	# check, if we have to print something
 
@@ -691,7 +713,7 @@ _print_progress_32:
 _enable_device_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                   # base register
-0:      s      %r15,.Lc96-0b(%r13)
+0:      ahi    %r15,-96
         lr     %r1,%r2
         lhi    %r2,EENABLE_DEV          # set panik code early
         stsch  .Ltmp_data-0b(%r13)
@@ -715,7 +737,7 @@ _enable_device_32:
 _ssch_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                    # base register
-0:      s      %r15,.Lc96-0b(%r13)       # create stack frame
+0:      ahi    %r15,-96                  # create stack frame
 	lhi    %r8,10                    # set retry count for ssch
         lr     %r12,%r2                  # save subchannel id
         lr     %r11,%r3                  # save orb
@@ -753,7 +775,7 @@ _ssch_32:
 _wait4de_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                   # base register
-0:      s      %r15,.Lc96-0b(%r13)      # create stack frame
+0:      ahi    %r15,-96                 # create stack frame
         lr     %r1,%r2
         mvc    0x78(8),6f-0b(%r13)      # set i/o new psw
 1:      lpsw   5f-0b(%r13)
@@ -778,16 +800,37 @@ _wait4de_32:
 .Lpsw:  .long  0x0
 
 ################################################################################
-# Panik routine. Loads a disabled wait psw
+# Panik routine. Loads a disabled wait psw or performs reipl if required.
 #   -r2 : panik code
 ################################################################################
 
 _panik_32:
 	stm    %r6,%r15,24(%r15)
 	basr   %r13,0                   # base register
-0:	s      %r15,.Lc96-0b(%r13)
-
+0:	ahi    %r15,-96
+	st     %r2,1f-0b+4(%r13)        # store code in address part of psw
 	bras   %r14,_print_exit_message
+
+	# perform reipl: check lowcore for the address of an IPL Information
+	# Block followed by a valid checksum (as defined in lowcore.h and set
+	# by ipl.c). In case of match use diag308 to IPL.
+
+	l     %r2,__LC_IPIB(%r0)                 # IPL Information Block
+	ltr   %r2,%r2                            # re-ipl required?
+	bz    .Lnoreipl-0b(%r13)                 # no, skip diag308
+	l     %r3,0(%r2)                         # length of IPIB
+	sr    %r1,%r1                            # zero accumator
+.Lcksmloop:
+	cksm  %r1,%r2                            # compute IPIB checksum
+	bnz   .Lcksmloop-0b(%r13)                # repeat if not complete
+	cl    %r1,__LC_IPIB+4(%r0)               # compare with cksm in lowcore
+	bne   .Lnoreipl-0b(%r13)                 # no match, skip diag308
+	l     %r2,__LC_IPIB(%r0)                 # reload IPL Information Block
+	lhi   %r4,DIAG308_SET                    # load subcode
+	diag  %r2,%r4,0x308                      # set IPL parameters
+	lhi   %r4,DIAG308_IPL                    # load subcode
+	diag  %r2,%r4,0x308                      # perform load clear
+.Lnoreipl:
 	lpsw   1f-0b(%r13)
 	.align 8
 1:	.long  0x000a0000,0x00000000
@@ -815,7 +858,7 @@ _panik_32:
 _take_dump_32:
         stm   %r6,%r15,24(%r15)
         basr  %r13,0
-.Lbase: s     %r15,.Lc96-.Lbase(%r13)            # create stack frame
+.Lbase: ahi   %r15,-96                           # create stack frame
 
 	sckc  .Lclock_comparator-.Lbase(%r13)    # set clock comparator to future
 	spt   .Lcpu_timer-.Lbase(%r13)           # set cpu timer to future
@@ -878,7 +921,7 @@ _take_dump_32:
 _count_mem_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                         # base register
-0:      s      %r15,.Lc96-0b(%r13)            # create stack frame
+0:      ahi    %r15,-96                       # create stack frame
 
         bras  %r14,_sclp_read_info
         chi   %r2,0
@@ -953,7 +996,7 @@ _count_mem_32:
 _create_ida_list_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                         # base register
-0:      s      %r15,.Lc96-0b(%r13)            # create stack frame
+0:      ahi    %r15,-96                       # create stack frame
 
         # setup new pgc psw for finding invalid pages
 
@@ -1009,7 +1052,7 @@ _create_ida_list_32:
 _store_status_32:
         stm   %r6,%r15,24(%r15)
         basr  %r13,0                          # base register
-0:      s     %r15,.Lc96-0b(%r13)
+0:      ahi   %r15,-96
         la    %r7,0x0                         # base register for 0 page
 
         ######## move lowcore info (assume user has made store  ########
@@ -1054,7 +1097,7 @@ _store_status_32:
 _copy_lowcore_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                         # base register
-0:      s      %r15,.Lc96-0b(%r13)
+0:      ahi    %r15,-96
 
         l      %r3,0x108(%r0)                 # get prefix page from lowcore
 
@@ -1116,7 +1159,7 @@ _copy_lowcore_32:
 _print_exit_message:
 	stm    %r6,%r15,24(%r15)
 	basr   %r13,0                         # base register
-0:	s      %r15,.Lc96-0b(%r13)
+0:	ahi    %r15,-96
 
 	lr     %r10,%r2
 
@@ -1224,9 +1267,8 @@ _print_exit_message:
 
 .Lmsg_start:
 	.byte 0xa9, 0xc9, 0xd7, 0xd3, 0x40, 0xa5
-	.byte 0xf0 + VERSION, 0x4b
-	.byte 0xf0 + RELEASE, 0x4b
-	.byte 0xf0 + PATCHLEVEL, 0x40
+	.byte S390_TOOLS_VERSION_EBCDIC
+	.byte 0x40
 	.byte 0x84, 0xa4, 0x94, 0x97, 0x40, 0xa3, 0x96, 0x96
 	.byte 0x93, 0x40, 0x4d
 #if defined(__s390x__)
Index: s390-tools-sles11/zipl/boot/eckd2dump.S
===================================================================
--- s390-tools-sles11.orig/zipl/boot/eckd2dump.S
+++ s390-tools-sles11/zipl/boot/eckd2dump.S
@@ -93,8 +93,6 @@ _start: 
         llgf   %r14,.Lenable_device_64-0b(%r13)
         basr   %r14,%r14
         bas    %r14,_get_device_characteristics_64-0b(%r13)
-        llgf   %r5,.Ldev_end_rec-0b(%r13)   # endblock (first block = nr 1) 
-        st     %r5,.Ldev_bpt-0b(%r13)      
         llgf   %r5,.Ldev_blk_size-0b(%r13)  # get blocksize
         stcm   %r5,3,.Lwrccw+2-0b(%r13)     # store blocksize into wr template
         stcm   %r5,3,.Llodata+14-0b(%r13)   # store blocksize into lodata
@@ -109,34 +107,26 @@ _start: 
 # Get device characteristics from zipl parameters (at 0x218)
 # The following parameter format is expected 2x8 byte:
 #
-# Dump Start: CCHH RBBN
-# Dump End:   CCHH RBBX
-#
-# - CC: Start/End Cylinder Number
-# - HH: Start/End Head Number
-# - R : Start/End Record Number
-# - BB: Blocksize
-# - N : Number of Heads of DASD
-# - X : Unused
-#
-# Cylinder, Heads are counted starting with 0.
-# Records are counted starting with 1.
-# We assume that the End Record Number is at track boundary.
-# This allows us to determine the number of Blocks Per Track.
+# struct eckd_dump_param {
+#       uint32_t        start_blk;
+#       uint32_t        end_blk;
+#       uint16_t        blocksize;
+#       uint8_t.        num_heads;
+#       uint8_t.        bpt;
+#       char            reserved[4];
+# } __attribute((packed));
 ################################################################################
 
 _get_device_characteristics_64:
         stmg   %r6,%r15,48(%r15)
         basr   %r13,0                   # base register
 0:      aghi   %r15,-200                # create stack frame
-        mvc    .Ldev_start_cyl-0b+2(2,%r13),0x218(%r0)
-        mvc    .Ldev_start_hd-0b+2(2,%r13),0x21a(%r0)
-        mvc    .Ldev_start_rec-0b+3(1,%r13),0x21c(%r0)
-        mvc    .Ldev_blk_size-0b+2(2,%r13),0x21d(%r0)
-        mvc    .Ldev_nr_hds-0b+3(1,%r13),0x21f(%r0)
-        mvc    .Ldev_end_cyl-0b+2(2,%r13),0x220(%r0)
-        mvc    .Ldev_end_hd-0b+2(2,%r13),0x222(%r0)
-        mvc    .Ldev_end_rec-0b+3(1,%r13),0x224(%r0)
+
+        mvc    .Ldev_start_blk-0b(4,%r13),0x218(%r0)
+        mvc    .Ldev_end_blk-0b(4,%r13),0x21c(%r0)
+        mvc    .Ldev_blk_size-0b+2(2,%r13),0x220(%r0)
+        mvc    .Ldev_nr_hds-0b+3(1,%r13),0x222(%r0)
+        mvc    .Ldev_bpt-0b+3(1,%r13),0x223(%r0)
         lmg    %r6,%r15,248(%r15)
         br     %r14
 
@@ -154,65 +144,6 @@ _dump_mem_64:    
 
 	bras %r14,_init_print_progress_64
 
-        # calculate start and end block
-
-        lghi    %r6,0
-        llgf    %r7,.Ldev_start_cyl-0b(%r13)
-        lghi    %r8,0
-        llgf    %r9,.Ldev_start_hd-0b(%r13)
-        llgf    %r10,.Ldev_start_rec-0b(%r13)
-        llgf    %r11,.Ldev_nr_hds-0b(%r13)
-        llgf    %r12,.Ldev_bpt-0b(%r13)       # = blocks per track
-
-        # calculate start block
-        #######################
-
-        # cyl * nr_hds * blkptr
-
-        mr      %r6,%r11
-        mr      %r6,%r12
-
-        # hd * recs
-
-        mr      %r8,%r12
-
-        # start block = cyl * nr_hds * bptr + hd * bptr + rec
-
-        ar      %r7,%r9
-        ar      %r7,%r10
-
-        bctr    %r7,0                         # decrement, we start counting
-                                              # beginning with block 0
-
-        st      %r7,.Ldev_start_blk-0b(%r13)
-        
-        
-
-        # calculate end block
-        #######################
-
-        llgf    %r7,.Ldev_end_cyl-0b(%r13)
-        llgf    %r9,.Ldev_end_hd-0b(%r13)
-
-        # cyl * nr_hds * blkptr
-
-        mr      %r6,%r11
-        mr      %r6,%r12
-
-        # hd * recs
-
-        mr      %r8,%r12
-
-        # end block = cyl * nr_hds * bptr + hd * bptr + rec
-
-        ar      %r7,%r9
-        ar      %r7,%r12
-
-        bctr    %r7,0                        # decrement, we start counting
-                                             # beginning with block 0
-
-        st      %r7,.Ldev_end_blk-0b(%r13)
-
         # calculate bytes per write (blksize * blwr)
 
         llgf    %r11,.Ldev_blk_size-0b(%r13)
@@ -375,8 +306,14 @@ _writeblock_64:
         xr      %r2,%r2                       # clear bot                  
         dr      %r2,%r7                       # cy=trk / heads, hd=trk % heads
                                               # r3: cy, r2: hd
+
+        lgr     %r8,%r3                       # r8=upper 12 bits of cylinder
+        srl     %r8,16                        # are coded into heads:
+        sll     %r8,4                         # c0c1c2h0 (2 byte)
+
         sll     %r3,16                        # combine to CCHH in r3
         or      %r3,%r2
+        or      %r3,%r8                       # add upper 12 bits
         st      %r3,.Ldedata+8-0b(%r13)       # store cchh to dedata
         st      %r3,.Llodata+4-0b(%r13)       # store cchh to lodata
         st      %r3,.Llodata+8-0b(%r13)       # store cchh to lodata
@@ -391,8 +328,14 @@ _writeblock_64:
 
         xr      %r4,%r4                       # cy2=tr2/heads, hd2=hd2 % heads
         dr      %r4,%r7                       # r5: cy2, r4: hd2
-        stcm    %r5,3,.Ldedata+12-0b(%r13)    # store cy2,hd2 to dedata
-        stcm    %r4,3,.Ldedata+14-0b(%r13)    # store cy2,hd2 to dedata
+
+        lgr     %r8,%r5                       # r8=upper 12 bits of cylinder
+        srl     %r8,16                        # are coded into heads:
+        sll     %r8,4                         # c0c1c2h0 (2 byte)
+        or      %r4,%r8
+
+        stcm    %r5,3,.Ldedata+12-0b(%r13)    # store cy2 to dedata
+        stcm    %r4,3,.Ldedata+14-0b(%r13)    # store hd2 to dedata
         lgr     %r5,%r11                      # restore r5
 
         # CCWs are setup now, arent they?
@@ -500,8 +443,6 @@ _start: basr   %r13,0
         l      %r14,.Lenable_device_32-0b(%r13)
         basr   %r14,%r14
         bas    %r14,_get_device_characteristics_32-0b(%r13)
-        l      %r5,.Ldev_end_rec-0b(%r13)   # endblock (first block = nr 1) 
-        st     %r5,.Ldev_bpt-0b(%r13)      
         l      %r5,.Ldev_blk_size-0b(%r13)  # get blocksize
         stcm   %r5,3,.Lwrccw+2-0b(%r13)     # store blocksize into wr template
         stcm   %r5,3,.Llodata+14-0b(%r13)   # store blocksize into lodata
@@ -517,34 +458,25 @@ _start: basr   %r13,0
 # Get device characteristics from zipl parameters (at 0x218)
 # The following parameter format is expected 2x8 byte:
 #
-# Dump Start: CCHH RBBN
-# Dump End:   CCHH RBBX
-#
-# - CC: Start/End Cylinder Number
-# - HH: Start/End Head Number
-# - R : Start/End Record Number
-# - BB: Blocksize
-# - N : Number of Heads of DASD
-# - X : Unused
-#
-# Cylinder, Heads are counted starting with 0.
-# Records are counted starting with 1.
-# We assume that the End Record Number is at track boundary.
-# This allows us to determine the number of Blocks Per Track.
+# struct eckd_dump_param {
+#       uint32_t        start_blk;
+#       uint32_t        end_blk;
+#       uint16_t        blocksize;
+#       uint8_t.        num_heads;
+#       uint8_t.        bpt;
+#       char            reserved[4];
+# } __attribute((packed));
 ################################################################################
 
 _get_device_characteristics_32:
         stm    %r6,%r15,24(%r15)
         basr   %r13,0                   # base register
 0:      s      %r15,.Lc96-0b(%r13)      # create stack frame
-        mvc    .Ldev_start_cyl-0b+2(2,%r13),0x218(%r0)
-        mvc    .Ldev_start_hd-0b+2(2,%r13),0x21a(%r0)
-        mvc    .Ldev_start_rec-0b+3(1,%r13),0x21c(%r0)
-        mvc    .Ldev_blk_size-0b+2(2,%r13),0x21d(%r0)
-        mvc    .Ldev_nr_hds-0b+3(1,%r13),0x21f(%r0)
-        mvc    .Ldev_end_cyl-0b+2(2,%r13),0x220(%r0)
-        mvc    .Ldev_end_hd-0b+2(2,%r13),0x222(%r0)
-        mvc    .Ldev_end_rec-0b+3(1,%r13),0x224(%r0)
+        mvc    .Ldev_start_blk-0b(4,%r13),0x218(%r0)
+        mvc    .Ldev_end_blk-0b(4,%r13),0x21c(%r0)
+        mvc    .Ldev_blk_size-0b+2(2,%r13),0x220(%r0)
+        mvc    .Ldev_nr_hds-0b+3(1,%r13),0x222(%r0)
+        mvc    .Ldev_bpt-0b+3(1,%r13),0x223(%r0)
         lm     %r6,%r15,120(%r15)
         br     %r14
 
@@ -562,65 +494,6 @@ _dump_mem_32:    
 
 	bras %r14,_init_print_progress_32
 
-        # calculate start and end block
-
-        la      %r6,0
-        l       %r7,.Ldev_start_cyl-0b(%r13)
-        la      %r8,0
-        l       %r9,.Ldev_start_hd-0b(%r13)
-        l       %r10,.Ldev_start_rec-0b(%r13)
-        l       %r11,.Ldev_nr_hds-0b(%r13)
-        l       %r12,.Ldev_bpt-0b(%r13)       # = blocks per track
-
-        # calculate start block
-        #######################
-
-        # cyl * nr_hds * blkptr
-
-        mr      %r6,%r11
-        mr      %r6,%r12
-
-        # hd * recs
-
-        mr      %r8,%r12
-
-        # start block = cyl * nr_hds * bptr + hd * bptr + rec
-
-        ar      %r7,%r9
-        ar      %r7,%r10
-
-        bctr    %r7,0                         # decrement, we start counting
-                                              # beginning with block 0
-
-        st      %r7,.Ldev_start_blk-0b(%r13)
-        
-        
-
-        # calculate end block
-        #######################
-
-        l       %r7,.Ldev_end_cyl-0b(%r13)
-        l       %r9,.Ldev_end_hd-0b(%r13)
-
-        # cyl * nr_hds * blkptr
-
-        mr      %r6,%r11
-        mr      %r6,%r12
-
-        # hd * recs
-
-        mr      %r8,%r12
-
-        # end block = cyl * nr_hds * bptr + hd * bptr + rec
-
-        ar      %r7,%r9
-        ar      %r7,%r12
-
-        bctr    %r7,0                        # decrement, we start counting
-                                             # beginning with block 0
-
-        st      %r7,.Ldev_end_blk-0b(%r13)
-
         # calculate bytes per write (blksize * blwr)
 
         l       %r11,.Ldev_blk_size-0b(%r13)
@@ -777,8 +650,14 @@ _writeblock_32:
         xr      %r2,%r2                       # clear bot                  
         dr      %r2,%r7                       # cy=trk / heads, hd=trk % heads
                                               # r3: cy, r2: hd
+
+        lr      %r8,%r3                       # r8=upper 12 bits of cylinder
+        srl     %r8,16                        # are coded into heads:
+        sll     %r8,4                         # c0c1c2h0 (2 byte)
+
         sll     %r3,16                        # combine to CCHH in r3
         or      %r3,%r2
+        or      %r3,%r8                       # add upper 12 bits
         st      %r3,.Ldedata+8-0b(%r13)       # store cchh to dedata
         st      %r3,.Llodata+4-0b(%r13)       # store cchh to lodata
         st      %r3,.Llodata+8-0b(%r13)       # store cchh to lodata
@@ -793,8 +672,14 @@ _writeblock_32:
 
         xr      %r4,%r4                       # cy2=tr2/heads, hd2=hd2 % heads
         dr      %r4,%r7                       # r5: cy2, r4: hd2
-        stcm    %r5,3,.Ldedata+12-0b(%r13)    # store cy2,hd2 to dedata
-        stcm    %r4,3,.Ldedata+14-0b(%r13)    # store cy2,hd2 to dedata
+
+        lr      %r8,%r5                       # r8=upper 12 bits of cylinder
+        srl     %r8,16                        # are coded into heads:
+        sll     %r8,4                         # c0c1c2h0 (2 byte)
+        or      %r4,%r8
+
+        stcm    %r5,3,.Ldedata+12-0b(%r13)    # store cy2 to dedata
+        stcm    %r4,3,.Ldedata+14-0b(%r13)    # store hd2 to dedata
         lr      %r5,%r11                      # restore r5
 
         # CCWs are setup now, arent they?
@@ -863,30 +748,16 @@ _writeblock_32:
 
 # device characteristics
 .align 8
-.Ldev_start_cyl:
-        .long  0x00000000
-.Ldev_start_hd:
-        .long  0x00000000
-.Ldev_start_rec:
-        .long  0x00000000
 .Ldev_blk_size:
         .long  0x00000000
 .Ldev_nr_hds:
         .long  0x00000000
-.Ldev_end_cyl:
-        .long  0x00000000
-.Ldev_end_hd:
-        .long  0x00000000
-.Ldev_end_rec:
+.Ldev_bpt:
         .long  0x00000000
-
-
 .Ldev_start_blk:
         .long  0x00000000
 .Ldev_end_blk:
         .long  0x00000000
-.Ldev_bpt:
-        .long  0x00000000
 
 
 
Index: s390-tools-sles11/zipl/boot/eckd2mvdump.S
===================================================================
--- s390-tools-sles11.orig/zipl/boot/eckd2mvdump.S
+++ s390-tools-sles11/zipl/boot/eckd2mvdump.S
@@ -38,7 +38,7 @@ _start:
 	basr  %r13,0
 .Linit_base:
 	la    %r9,0
-	st    %r9,.Ldh_arch-.Linit_base(%r13) # init arch 
+	st    %r9,.Ldh_arch-.Linit_base(%r13) # init arch
 	l     %r15,1f-.Linit_base(%r13)       # load end of stack address
 	la    %r7,0
 	tm    __LC_ARCH_MODE_ID(%r9),0x01     # check arch mode
@@ -93,7 +93,7 @@ _start:
 #  -no parameters
 ################################################################################
 
-_dump_mem_64:    
+_dump_mem_64:
 	stmg   %r6,%r15,48(%r15)
 	basr   %r13,0                         # base register
 0:      aghi   %r15,-200                      # create stack frame
@@ -119,7 +119,7 @@ _dump_mem_64:    
 
 	# calculate number of blocks required to store header
 	llgf    %r4,.Lheader_size-0b(%r13)
-	srda    %r4,32                        # shift ==> 64 bit number        
+	srda    %r4,32                        # shift ==> 64 bit number
 	llgf    %r6,.Ldev_blk_size-0b(%r13)   # get blocksize
 	dr      %r4,%r6                       # nr of blocks for header =
                                               # HEADER_SIZE / BLOCKSIZE = r5
@@ -183,7 +183,7 @@ _dump_mem_64:    
 					      # boundary
 	mvc     512(8,%r3),.Ldh_magic_number-0b(%r13) # preserve signature
 	lgr     %r4,%r5
-	lgr     %r12,%r5                      # save nr of blocks        
+	lgr     %r12,%r5                      # save nr of blocks
 	bas     %r14,_ioblock_64-0b(%r13)     # write block to disk
 	ar      %r11,%r12                     # update block counter
 
@@ -372,7 +372,7 @@ _ioblock_64:
 	llgf    %r6,.Ldev_end_rec-0b(%r13)    # load blocks per track to r6
 	llgf    %r7,.Ldev_nr_hds-0b(%r13)     # load heads to r7
 	la      %r5,.Lwrloop-0b(%r13)
-	br      %r5 
+	br      %r5
 
 2:      # loop for number of block (nbl) time
 
@@ -387,7 +387,7 @@ _ioblock_64:
 	# build up next write CCW
 	l       %r9,0(%r3)                    # test page
 	lgr     %r9,%r3
-	b       .Lpage_ok-0b(%r13) 
+	b       .Lpage_ok-0b(%r13)
 .Lpage_invalid:
 	lghi    %r9,ZERO_PAGE_START
 .Lpage_ok:
@@ -396,27 +396,33 @@ _ioblock_64:
 	bct     %r4,2b-0b(%r13)               # decrement no of blks still to do
 	ni      1(%r12),0x3f                  # no command chaining for last ccw
 
-	# write CCWs are setup now               
+	# write CCWs are setup now
 	lgr     %r4,%r11                      # restore number of blocks
 	stcm    %r4,3,.Llodata+2-0b(%r13)     # store number of blocks to lodata
 
-	# compute end block 
-	agr     %r4,%r2                       # r4: ebl = blk + nbl 
+	# compute end block
+	agr     %r4,%r2                       # r4: ebl = blk + nbl
 	bctr    %r4,0                         # decrement r4 (last blk touched)
 
 	# compute start track and start block on track
-	srda    %r2,32                        # shift ==> 64 bit number 
+	srda    %r2,32                        # shift ==> 64 bit number
 	dr      %r2,%r6                       # trk = blk / bpt, bot = blk % bpt
 	                                      # r3: trk, r2: bot
 	la      %r2,1(%r2)                    # bot++ ( we start counting at 1 )
 	stcm    %r2,1,.Llodata+12-0b(%r13)    # store bot to lodata
 
 	# compute start cylinder and head
-	xr      %r2,%r2                       # clear bot                  
+	xr      %r2,%r2                       # clear bot
 	dr      %r2,%r7                       # cy=trk / heads, hd=trk % heads
 	                                      # r3: cy, r2: hd
+
+	lgr     %r8,%r3                       # r8=upper 12 bits of cylinder
+	srl     %r8,16                        # are coded into heads:
+	sll     %r8,4                         # c0c1c2h0 (2 byte)
+
 	sll     %r3,16                        # combine to CCHH in r3
 	or      %r3,%r2
+	or      %r3,%r8                       # add upper 12 bits
 	st      %r3,.Ldedata+8-0b(%r13)       # store cchh to dedata
 	st      %r3,.Llodata+4-0b(%r13)       # store cchh to lodata
 	st      %r3,.Llodata+8-0b(%r13)       # store cchh to lodata
@@ -429,8 +435,14 @@ _ioblock_64:
 	# compute end cylinder and head
 	xr      %r4,%r4                       # cy2=tr2/heads, hd2=hd2 % heads
 	dr      %r4,%r7                       # r5: cy2, r4: hd2
-	stcm    %r5,3,.Ldedata+12-0b(%r13)    # store cy2,hd2 to dedata
-	stcm    %r4,3,.Ldedata+14-0b(%r13)    # store cy2,hd2 to dedata
+
+	lgr     %r8,%r5                       # r8=upper 12 bits of cylinder
+	srl     %r8,16                        # are coded into heads:
+	sll     %r8,4                         # c0c1c2h0 (2 byte)
+	or      %r4,%r8
+
+	stcm    %r5,3,.Ldedata+12-0b(%r13)    # store cy2 to dedata
+	stcm    %r4,3,.Ldedata+14-0b(%r13)    # store hd2 to dedata
 	lgr     %r5,%r11                      # restore r5
 
 	# CCWs are setup now, arent they?
@@ -459,7 +471,7 @@ _ioblock_64:
 .Lpage_invalid_psw:
 	.long 0x00000001,0x80000000,0x00000000,0x00000000 + .Lpage_invalid
 .Lold_pgc_psw:
-	.long 0x0,0x0,0x0,0x0 
+	.long 0x0,0x0,0x0,0x0
 
 ################################################################################
 # expand Macros
@@ -478,7 +490,7 @@ _ioblock_64:
 	sclp_read_info
 
 # extern functions
- 
+
 .Lpanik_64:
 	.long      _panik_64
 .Lenable_device_64:
